/// <reference path='./babylon.d.ts' />
var scene;
var camera;
async function createScene() {


    async function initScene() {

        scene = new BABYLON.Scene(engine);
        //scene.debugLayer.show();
        scene.clearColor = new BABYLON.Color3.FromInts(30, 30, 35);

        //camera = new BABYLON.ArcRotateCamera("camera", Math.PI/2, 3, 10, new BABYLON.Vector3(0.0, 0.0, 0.0), scene);
        camera = new BABYLON.ArcRotateCamera("Cam_config", -Math.PI, Math.PI/2,0, new BABYLON.Vector3(0,0,0), scene);
        camera.setTarget(new BABYLON.Vector3(0, 0, 0))
        //camera.setPosition(new BABYLON.Vector3(33.9, 7.84, -64.5))
        //camera.fov = 0.5;


        
        camera.upperRadiusLimit = 100;
        camera.lowerRadiusLimit = 1;
        camera.wheelPrecision = 50;
        camera.allowUpsideDown = true;
        camera.minZ = 0.1;
        scene.activeCamera = camera;
        scene.activeCamera.attachControl(canvas);


        //dirLight = new BABYLON.DirectionalLight("dirLight", new BABYLON.Vector3(0.60, -0.7, 0.63), scene);
       // dirLight.position = new BABYLON.Vector3(-0.05, 0.35, -0.05);
        //dirLight.shadowMaxZ = 0.45;
        //dirLight.intensity = 0.5;



        var hdrTexture = BABYLON.CubeTexture.CreateFromPrefilteredData("img/studio.env", scene);
        hdrTexture.gammaSpace = false;
        var envTexture = BABYLON.CubeTexture.CreateFromPrefilteredData("img/studio.env", scene);



        scene.environmentTexture = hdrTexture;//只影响材质，不带skybox
        scene.environmentIntensity =1

        scene.createDefaultSkybox(envTexture, true, 10000);//带skybox
        hdrTexture.gammaSpace = false;
        hdrTexture.rotationY = BABYLON.Tools.ToRadians(0);
        scene.environmentTexture = hdrTexture;






        //scene.createDefaultEnvironment({
        //environmentTexture: "img/environment.env"
        //});



        //var hdrTexture = new BABYLON.CubeTexture.CreateFromPrefilteredData("img/environment.env", scene);
        //scene.environmentTexture = hdrTexture;

        scene.debugLayer.show(true);


        //new BABYLON.PassPostProcess("scale_pass", 2, camera, BABYLON.Texture.LINEAR_LINEAR_MIPNEAREST);


        scene.onBeforeRenderObservable.add(function () {
            //console.log("pos:"+camera.position)
            //console.log("tar:"+camera.target)

        });
    }
    const meshes = {};
    async function loadMeshes() {
        meshes.file = await BABYLON.SceneLoader.AppendAsync("Assets/chanchu.glb");


      
        meshes.chanchu = scene.getMeshByName("chanchu");
        

    };
    const meshesMats = {};
    async function createMaterials() {
        // node material for glass
        meshesMats.glass = new BABYLON.NodeMaterial("glassMat", scene, { emitComments: false });
        await meshesMats.glass.loadAsync("matNode/nodeMaterial.json");
        meshesMats.glass.build(false);

        // need depth pre pass for refraction to work correctly
        meshesMats.glass.needDepthPrePass = true;

        // assign material to mesh
        //meshes.demo.material =  meshesMats.glass;
        //meshes.masterExterior.material = meshes.masterInterior.material = meshesMats.glass;
        meshes.chanchu.material = meshesMats.glass;
        meshes.chanchu.scaling = new BABYLON.Vector3(1.001, 1, 1);
      
    }
    initScene();
    await loadMeshes();
    await createMaterials();




    engine.runRenderLoop(function () {
        scene.render();
    });


    // Resize
    window.addEventListener("resize", function () {
        engine.resize();
    });
}